<?php
/**
 * 2018-2022 MXB Informatica.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to info@mxbinformatica.it so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    MXB Informatica <info@mxbinformatica.it>
 *  @copyright 2013-2022 MXB Informatica
 *  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 */

include_once('../../config/config.inc.php');
include_once('../../init.php');
include_once('customName.php');

// require_once _PS_MODULE_DIR_.'mxb_tools/classes/MxbToolsDebug.php';

$customName = mxbGetCustomName();
$tableName = 'mxb_customblocks_' . $customName;
include_once('mxb_customblocks_' . $customName . '.php');

$home_slider_class = 'Mxb_Customblocks_' . ucfirst($customName);
$home_slider = new $home_slider_class(); //Ps_ImageSlider();
// $slides = array();

// frontoffice ajax
if (Tools::getValue('action') == 'getSlideElement' && Tools::getValue('type') && Tools::getValue('id')) {
    $type = Tools::getValue('type');
    $id = (string)Tools::getValue('id');
    $group = (Tools::getIsset('group') ? (int)Tools::getValue('group') : 1);
    $id_lang = (int) Context::getContext()->language->id;
    $rnd = false;
    $id_category = 0;
    $id_manufacturer = 0;
    $ret = [
        'type' => $type,
        'blockqty' => $group,
        'name' => '',
        'description' => '',
        'imgurl' => '',
        'link' => '',
    ];
    /*
    MxbToolsDebug::WriteLog($home_slider_class, 'ajax', 'start: '
        . ' id="'.$id
        . ', group="'.$group
        . ', ret="'.print_r($ret, true),
        true);
    */
    if (strtolower($id) == 'rnd' || strtolower($id) == 'random') {
        // $id = 0;
        $id = [0];
        $rnd = true;
    } elseif (strpos(strtolower($id), 'cat') !== false || strpos(strtolower($id), 'category') !== false) {
        // $id = (int)$id; // save category id
        $id_category = (int)preg_replace('/[^0-9]/', '', $id);
        // $id = 0;
        $id = [0];
        $rnd = true;    // we'll get a random product for above category id
    } elseif (strpos(strtolower($id), 'man') !== false || strpos(strtolower($id), 'brand') !== false) {
        $id_manufacturer = (int)preg_replace('/[^0-9]/', '', $id);
        //$id = 0;
        $id = [0];
        $rnd = true;    // we'll get a random product for above manufacturer/category id
    } elseif (strpos($id, ',') !== false || strpos($id, ';') !== false) {
        $id = str_replace(' ', '', $id);
        $id = str_replace(';', ',', $id);
        $idArr = explode(',', $id);
        $rnd_idx = array_rand($idArr, $group);
        if (!is_array($rnd_idx)) {
            $rnd_idx = [$rnd_idx];
        }
        // $id = (int)$idArr[$rnd_idx];
        $id = [];
        foreach ($rnd_idx as $idx) {
            $id[] = (int)$idArr[$idx];
        }
    } else {
        $id = [$id];
    }
    
    
    // MxbToolsDebug::WriteLog($home_slider_class, 'ajax', 'type='.$type.', id="'.print_r($id, true), true);
    
    switch ($type) {
        case 'product':
            // random
            if ($rnd) {
                if ((int)$id_category > 0) {
                    // random product for id_category
                    $sql = '
                        SELECT cp.id_product, p.active
                        FROM `'._DB_PREFIX_.'category_product` cp
                        INNER JOIN `'._DB_PREFIX_.'product` p ON (p.id_product = cp.id_product)
                        WHERE p.active = 1
                        AND cp.id_category = ' . (int)$id_category . '
                        ORDER BY rand() LIMIT ' . (int)$group;
                } elseif ((int)$id_manufacturer > 0) {
                    // random product for id_category
                    $sql = '
                        SELECT id_product
                        FROM `'._DB_PREFIX_.'product`
                        WHERE active = 1
                        AND id_manufacturer = ' . (int)$id_manufacturer . '
                        ORDER BY rand() LIMIT ' . $group;
                } else {
                    // random product
                    $sql = '
                        SELECT id_product
                        FROM `'._DB_PREFIX_.'product`
                        WHERE active = 1
                        ORDER BY rand() LIMIT ' . $group;
                }
                $result = Db::getInstance()->executeS($sql);
                
                
                // MxbToolsDebug::WriteLog($home_slider_class, 'ajax', 'get rnd elements - sql=' . $sql . ', result="'.print_r($result, true), true);
                
                if (!$result) {
                    break;
                }
                // $id = $result[0]['id_product'];
                $id = [];
                $gr = $group;
                for ($i=0; $i<(int)$gr && $i<count($result); $i++) {
                    $id[] = $result[$i]['id_product'];
                    // correct thumb quantity as products quantity found
                    $group = $i+1;
                }
                // MxbToolsDebug::WriteLog($home_slider_class, 'ajax', 'product id collected: id="'.print_r($id, true), true);
            }

            // get data
            foreach ($id as $idKey => $idRecord) {
                $res = new Product((int)$idRecord, false, (int)$id_lang);
                if (Validate::isLoadedObject($res)) {
                    // get image url

                    // $imgs = $res->getImages($id_lang);
                    $idImage = Product::getCover($idRecord);
                    $image_url = '';
                    if (is_array($idImage) && count($idImage)) {
                        $idImage = (string)$idImage['id_image'];
                        $imgPath = _PS_PROD_IMG_DIR_;
                        $idPath = '';
                        for ($i = 0; $i < strlen($idImage); $i++) {
                            $idPath .= $idImage[$i] . '/';
                        }
                        // $imgPath .= $idImage . '.jpg';
                        // $image_url = Context::getContext()->link->getMediaLink($imgPath);
                        
                        $img_type = $idImage; // id, id-cart_default, id-home_default, id-small_default, id-medium_default, id-small_default
                        
                        $files = scandir($imgPath.$idPath);
                        // $image_links = array();
                        $image_url = '';
                        if (count($files) > 0) {
                            foreach ($files as $file) {
                                if (strpos($file, $img_type . '.jpg') !== false) {
                                    $image_url = Context::getContext()->link->getMediaLink(_THEME_PROD_DIR_.$idPath.$file);
                                    // $image_links[] = $image_url;
                                    break;
                                }
                            }
                        }
                        
                    }

                    $retArr = [
                        'type' => $type,
                        'blockqty' => $group,
                        'id' => $res->id,
                        'name' => $res->name,
                        'description' => strip_tags($res->description_short),
                        'imgurl' => $image_url,
                        'url' => $res->getLink(),
                    ];
                    if (count($id) === 1 || $idKey === 0) {
                        $ret = $retArr;
                    }
                    if (count($id) > 1) {
                        if (!isset($ret['group'])) {
                            $ret['group'] = [];
                        }
                        $ret['group'][] = $retArr;
                    }
                }
            }

            break;

        case 'category':
            // random
            if ($rnd) {
                $rootcat = (int) Configuration::get('PS_ROOT_CATEGORY');
                $sql = '
                    SELECT id_category
                    FROM `'._DB_PREFIX_.'category`
                    WHERE active = 1
                    AND id_category <> ' . (int)$rootcat . '
                    ORDER BY rand() LIMIT 1
                ';
                $result = Db::getInstance()->executeS($sql);
                if (!$result) {
                    break;
                }
                // $id = $result[0]['id_category'];
                $id = [];
                for ($i=0; $i<$group && $i<count($result); $i++) {
                    $id[] = $result[$i]['id_category'];
                    // correct thumb quantity as products quantity found
                    $group = $i+1;
                }
            }

            // get data
            foreach ($id as $idKey => $idRecord) {
                $res = new Category((int)$idRecord, (int)$id_lang);
                if (Validate::isLoadedObject($res)) {
                    // get image url
                    $img_type = 'small_default'; // '_thumb' / 'home_default' / 'small_default'
                    $files = scandir(_PS_CAT_IMG_DIR_);
                    // $image_links = array();
                    $image_url = '';
                    if (count(preg_grep('/^'.$idRecord.'-([0-9])?' . $img_type . '.jpg/i', $files)) > 0) {
                        foreach ($files as $file) {
                            if (preg_match('/^'.$idRecord.'-([0-9])?' . $img_type . '.jpg/i', $file) === 1) {
                                $image_url = Context::getContext()->link->getMediaLink(_THEME_CAT_DIR_.$file);
                                // $image_links[] = $image_url;
                                break;
                            }
                        }
                    }

                    $retArr = [
                        'type' => $type,
                        'blockqty' => $group,
                        'id' => $res->id,
                        'name' => $res->name,
                        'description' => strip_tags($res->meta_description),
                        'imgurl' => $image_url,
                        'url' => $res->getLink(),
                    ];
                    if (count($id) === 1 || $idKey === 0) {
                        $ret = $retArr;
                    }
                    if (count($id) > 1) {
                        if (!isset($ret['group'])) {
                            $ret['group'] = [];
                        }
                        $ret['group'][] = $retArr;
                    }
                }
            }

            break;

        case 'cms':
            // random
            if ($rnd) {
                $rootcat = (int) Configuration::get('PS_ROOT_CATEGORY');
                $sql = '
                    SELECT id_cms
                    FROM `'._DB_PREFIX_.'cms`
                    WHERE active = 1
                    ORDER BY rand() LIMIT 1
                ';
                $result = Db::getInstance()->executeS($sql);
                if (!$result) {
                    break;
                }
                // $id = $result[0]['id_cms'];
                $id = [];
                for ($i=0; $i<$group && $i<count($result); $i++) {
                    $id[] = $result[$i]['id_cms'];
                    // correct thumb quantity as products quantity found
                    $group = $i+1;
                }
            }


            // get data
            foreach ($id as $idKey => $idRecord) {
                $res = new CMS((int)$idRecord, (int)$id_lang);
                if (Validate::isLoadedObject($res)) {
                    $cms_link = '';
                    $cms = CMS::getLinks((int)$id_lang, array($idRecord));
                    if (count($cms)) {
                        $cms_link = $cms[0]['link'];
                    }
                    $retArr = [
                        'type' => $type,
                        'blockqty' => $group,
                        'id' => $res->id,
                        'name' => $res->meta_title,
                        'description' => $res->meta_description,
                        'imgurl' => '',
                        'url' => $cms_link,
                    ];
                    if (count($id) === 1 || $idKey === 0) {
                        $ret = $retArr;
                    }
                    if (count($id) > 1) {
                        if (!isset($ret['group'])) {
                            $ret['group'] = [];
                        }
                        $ret['group'][] = $retArr;
                    }
                }
            }

            break;

        case 'manufacturer':
            // random
            if ($rnd) {
                $rootcat = (int) Configuration::get('PS_ROOT_CATEGORY');
                $sql = '
                    SELECT id_manufacturer
                    FROM `'._DB_PREFIX_.'manufacturer`
                    WHERE active = 1
                    ORDER BY rand() LIMIT 1
                ';
                $result = Db::getInstance()->executeS($sql);
                if (!$result) {
                    break;
                }
                // $id = $result[0]['id_manufacturer'];
                $id = [];
                for ($i=0; $i<$group && $i<count($result); $i++) {
                    $id[] = $result[$i]['id_manufacturer'];
                    // correct thumb quantity as products quantity found
                    $group = $i+1;
                }
            }


            // get data
            foreach ($id as $idKey => $idRecord) {
                $res = new Manufacturer((int)$idRecord, (int)$id_lang);
                if (Validate::isLoadedObject($res)) {
                    // get manufacturer image url
                    $img_type = 'medium_default'; // 'small_default' / 'medium_default' / 'large_default'
                    $files = scandir(_PS_MANU_IMG_DIR_);
                    // $image_links = array();
                    $image_url = '';
                    if (count(preg_grep('/^'.$idRecord.'-'.$img_type.'.*/i', $files)) > 0) {
                        foreach ($files as $file) {
                            if (preg_match('/^'.$idRecord.'-'.$img_type.'.*/i', $file) === 1) {
                                $image_url = Context::getContext()->link->getManufacturerImageLink($idRecord, $img_type);
                                // $image_links[] = $image_url;
                                break;
                            }
                        }
                    }

                    $retArr = [
                        'type' => $type,
                        'blockqty' => $group,
                        'id' => $res->id,
                        'name' => $res->name,
                        'description' => strip_tags($res->short_description),
                        'imgurl' => $image_url,
                        'url' => Context::getContext()->link->getManufacturerLink(
                            $res,
                            null,
                            $id_lang
                        ),
                    ];
                    if (count($id) === 1 || $idKey === 0) {
                        $ret = $retArr;
                    }
                    if (count($id) > 1) {
                        if (!isset($ret['group'])) {
                            $ret['group'] = [];
                        }
                        $ret['group'][] = $retArr;
                    }
                }
            }

            break;
    }
    /* test
    $ret['group'] = [
        [
            'type' => $type,
            'id' => 1,
            'name' => 'one',
            'description' => 'desc one',
            'imgurl' => 'imgurl-one',
            'url' => 'url-one',
        ],
        [
            'type' => $type,
            'id' => 2,
            'name' => 'two',
            'description' => 'desc two',
            'imgurl' => 'imgurl-two',
            'url' => 'url-two',
        ],
    ];
    */
    
    header("Content-type: application/json");
    die(json_encode($ret));
}


// backoffice ajax
if (!Tools::isSubmit('secure_key') || Tools::getValue('secure_key') != $home_slider->secure_key || !Tools::getValue('action')) {
    die(1);
}

if (Tools::getValue('action') == 'updateSlidesPosition' && Tools::getValue('slides'))
{
    $slides = Tools::getValue('slides');
    //Die(print_r($slides, true));
    foreach ($slides as $position => $id_slide)
        $res = Db::getInstance()->execute('
            UPDATE `'._DB_PREFIX_.$tableName . '_slides` SET `position` = '.(int)$position.'
            WHERE `id_'.$tableName.'_slides` = '.(int)$id_slide
        );
    $home_slider->clearCache();
}
