{*
/**
 * 2018-2022 MXB Informatica.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to info@mxbinformatica.it so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    MXB Informatica <info@mxbinformatica.it>
 *  @copyright 2013-2022 MXB Informatica
 *  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 */
*}

{if $customblocks.slides}
    <style>
        .mxb_customblocks .read-more {
            max-height: {$customblocks.read_more_max_height|cleanHtml nofilter}px !important;
        }
    </style>
    
    <div class="mxb_customblocks" id="mxb_customblocks_{$customblocks.name|cleanHtml nofilter}">
        {foreach from=$customblocks.slides item=slide name='customblocks'}
            <div class="{if $customblocks.effect_on_scroll}mxb-transition-container{/if}">
                <div class="{if $customblocks.effect_on_scroll}{$slide.transition|cleanHtml nofilter}{/if}">
                    <div class="mxb_customblock {if $slide.image_url}with-image{/if} {if $slide.repeat_bg}repeat-bg{/if} {if $slide.custom_class}{$slide.custom_class|cleanHtml nofilter}{/if}"
                        {if $slide.image_url}
                            style="background-image:url('{$slide.image_url|cleanHtml nofilter}'); {if $slide.fixed_bg}background-attachment:fixed;{/if} margin-top:{$customblocks.margin|cleanHtml nofilter}px; {$slide.css_size|cleanHtml nofilter} "
                        {/if}
                        >
                        {if $slide.url}
                            <a href="{$slide.url|cleanHtml nofilter}">
                        {/if}

                        <figure>
                            {*if $slide.image_url}
                                <img src="{$slide.image_url|cleanHtml nofilter}" alt="{$slide.legend|escape}" loading="lazy" {if $slide.size}{$slide.size|cleanHtml nofilter}{else}width="1110" height="340"{/if}>
                            {/if*}
                            {if $slide.title || $slide.description || isset($slide.cms_content)}
                                <figcaption class="caption {if $slide.image_url}with-image{/if}">
                                    <h2 class="{*display-1 *}text-uppercase">{$slide.title|cleanHtml nofilter}</h2>
                                    <div class="caption-description">{$slide.description|cleanHtml nofilter}</div>
                                    {if isset($slide.cms_content)}
                                        <div>{$slide.cms_content|cleanHtml nofilter}</div>
                                    {/if}
                                </figcaption>
                            {/if}
                        </figure>

                        {if $slide.url}
                              </a>
                        {/if}
                    </div>
                </div>
                {if isset($slide.read_more)}
                    <div class="read-more-nav">
                        <span class="read-more-open-btn">
                            &raquo; {$customblocks.read_more_open_text|cleanHtml nofilter}
                        </span>
                        <span class="read-more-close-btn" style="display:none;">
                            &raquo; {$customblocks.read_more_close_text|cleanHtml nofilter}
                        </span>
                    </div>
                {/if}
            </div>
        {/foreach}
    </div>
{/if}